import os
import numpy as np

images_data_path = '/Users/edz/Downloads/makeupdataset/all/images'
segs_data_path = '/Users/edz/Downloads/makeupdataset/all/segs'

images_makeup = os.path.join(images_data_path,"makeup")
segs_makeup = os.path.join(segs_data_path,"makeup")
images_nonmakeup = os.path.join(images_data_path,"non-makeup")
segs_nonmakeup = os.path.join(segs_data_path,"non-makeup")

images_makeup_files = os.listdir(images_makeup)
images_nonmakeup_files = os.listdir(images_nonmakeup)
segs_makeup_files = os.listdir(segs_makeup)
segs_nonmakeup_files = os.listdir(segs_nonmakeup)

print("images_makeup_files:{}个".format(len(images_makeup_files)))
print("images_nonmakeup_files:{}个".format(len(images_nonmakeup_files)))
print("segs_makeup_files:{}个".format(len(segs_makeup_files)))
print("segs_nonmakeup_files:{}个".format(len(segs_nonmakeup_files)))

images_makeup_files = list(set(images_makeup_files)&set(segs_makeup_files))
images_nonmakeup_files = list(set(images_nonmakeup_files)&set(segs_nonmakeup_files))
print("images_makeup_files:{}个".format(len(images_makeup_files)))
print("images_nonmakeup_files:{}个".format(len(images_nonmakeup_files)))

np.random.shuffle(images_makeup_files)
np.random.shuffle(images_nonmakeup_files)

with open("./train_makeup.txt","w") as f:
    for images_makeup_file in images_makeup_files[:2448]:
        f.write("{} {}\n".format(os.path.join(images_makeup,images_makeup_file),os.path.join(segs_makeup,images_makeup_file)))
with open("./test_makeup.txt","w") as f:
    for images_makeup_file in images_makeup_files[2448:]:
        f.write("{} {}\n".format(os.path.join(images_makeup,images_makeup_file),os.path.join(segs_makeup,images_makeup_file)))

with open("./train_nonmakeup.txt","w") as f:
    for images_nonmakeup_file in images_nonmakeup_files[:1004]:
        f.write("{} {}\n".format(os.path.join(images_nonmakeup,images_nonmakeup_file),os.path.join(segs_nonmakeup,images_nonmakeup_file)))
with open("./test_nonmakeup.txt","w") as f:
    for images_nonmakeup_file in images_nonmakeup_files[1004:]:
        f.write("{} {}\n".format(os.path.join(images_nonmakeup,images_nonmakeup_file),os.path.join(segs_nonmakeup,images_nonmakeup_file)))